include hs.inc

.code
Start:
	push	0
	call	GetModuleHandle
	mov	hInstance, eax
	call	InitCommonControls
	call	WinMain
	
	push	eax
	call	ExitProcess
	
WinMain proc uses esi edi
LOCAL	wc		:WNDCLASSEX
LOCAL	msg		:MSG

	mov	wc.cbSize, sizeof WNDCLASSEX
	mov	wc.style, CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
	mov	wc.lpfnWndProc, offset ProcMain
	mov	wc.cbClsExtra, NULL
	mov	wc.cbWndExtra, NULL    
	m3m	wc.hInstance, eax, hInstance
	mov	wc.hbrBackground, COLOR_3DFACE + 1
	mov	wc.lpszMenuName, NULL 
	mov	wc.lpszClassName, OFFSET WndClsMain
	mov	wc.hIcon, 0
	mov     wc.hIconSm, 0
	
	push    IDC_ARROW		; Load default cursor from OS
	push    0			;
	call    LoadCursor		;
	mov     wc.hCursor, eax		;
	
	lea     eax, wc
	push    eax
	call    RegisterClassEx
	
	push    SM_CXSCREEN ; width	; Get coords to center window
	call    GetSystemMetrics	;
	sub     eax, 340		;
	shr     eax, 1			;                         
	push    eax			;
					;	
	push    SM_CYSCREEN ; height	;
	call    GetSystemMetrics	;
	sub     eax, 390		;
	shr     eax, 1			;
	pop     ebx			;
	
	push    0			; Create Main Window
	push    hInstance		;
	push    0			; 
	push    0			;
	push    390			; Height
	push    340			; Width
	push    eax			; Top
	push    ebx			; Left
	push    WS_CAPTION\		;
		or WS_CLIPCHILDREN\	;
		or WS_VISIBLE\		;
		or WS_SYSMENU		;
	push    offset AppName		;
	push    offset WndClsMain	;
	push    WS_EX_APPWINDOW		;
	call    CreateWindowEx		;
	
StartLoop:
	invoke	GetMessage, addr msg, NULL, 0, 0 
	test	eax, eax
	jz	ExitLoop
	invoke	TranslateMessage, addr msg 
	invoke	DispatchMessage, addr msg
	jmp	StartLoop
	    
ExitLoop:    
	mov	eax, msg.wParam
	ret
WinMain endp

ProcMain proc uses ebx hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
LOCAL	hDC		:DWORD
LOCAL	Ps		:PAINTSTRUCT
LOCAL	lfnt		:LOGFONT
LOCAL	Rc		:RECT

.if uMsg == WM_PAINT
	invoke	BeginPaint, hWnd, ADDR Ps
	mov	hDC, eax
	push	hDC
	push	hWnd
	call	Paint_Proc
	invoke	EndPaint, hWnd, ADDR Ps
	mov	eax, 0
	ret

.elseif uMsg ==  WM_COMMAND
	mov	eax, wParam
	.if ax == 1
		push	MB_OK\
			or MB_ICONERROR
		push	offset szMe
		push	offset szNo1
		push	hWnd
		call	MessageBox
	.elseif ax == 2
		push	0
		push	0
		push	WM_CLOSE
		push	hWnd
		call	SendMessage

	.elseif ax ==3
		push	MB_OK\
			or MB_ICONERROR
		push	offset szMe
		push	offset szNo2
		push	hWnd
		call	MessageBox
	.endif
	mov	eax, 0
	ret
	
.elseif uMsg == WM_CREATE
	invoke	RtlZeroMemory, addr lfnt, sizeof lfnt
	mov	lfnt.lfHeight, -12
	mov	lfnt.lfWeight, FW_NORMAL
	invoke	lstrcat, addr lfnt.lfFaceName, offset szFontName
	invoke	CreateFontIndirect, addr lfnt
	mov	hFont, eax    

					; #####################################
					; Sub title static control
	push	0			; 
	push	hInstance		;
	push	0			;
	push	hWnd			;
	push	20			; Height
	push	260			; Width
	push	5			; Top
	push	5			; Left
	push	WS_CHILD\		;
		or WS_VISIBLE		;
	push	offset Text1		; 
	push	offset WndClsStatic	;
	push	0			;
	call	CreateWindowEx		;
	push	-1			; Set font
	push	hFont			;
	push	WM_SETFONT		;
	push	eax			;
	call	SendMessage		;
 	
					; #####################################
					; Endurance options static control                  
	push	0 			;    
	push	hInstance		;
	push	0			;
	push	hWnd			;
	push	20			; Height
	push	100			; Width
	push	25			; Top
	push	5			; Left
	push	WS_CHILD\		;
		or WS_VISIBLE		;
	push	offset Text2		;
	push	offset WndClsStatic	;
	push	0			;
	call	CreateWindowEx		;
	
	push	-1			; Set font
	push	hFont			;
	push	WM_SETFONT		;
	push	eax			;
	call	SendMessage		;

    					; #####################################
					; Crash every button control
	push	0			;
	push	hInstance		;
	push	0			;
	push	hWnd			;
	push	20			; Height
	push	80			; Width
	push	45			; Top
	push	10			; Left
	push	WS_CHILD\		;
		or WS_VISIBLE\		;
		or BS_AUTOCHECKBOX 	;
	push	offset Text3		; 
	push	offset WndClsButton	;
	push	0			;
	call	CreateWindowEx		;

	push	-1			; Set font
	push	hFont			;
	push	WM_SETFONT		;
	push	eax			;
	call	SendMessage		;

					; #####################################
					; Crash every edit\updown control
	push	0			;        
	push	hInstance		;
	push	0			;
	push	hWnd			;
	push	20			; Height
	push	50			; Width
	push	45			; Top
	push	90			; Left
	push	WS_CHILD\		;
		or WS_VISIBLE\		;
		or ES_NUMBER
	push	0			; 
	push	offset WndClsEdit	;
	push	WS_EX_CLIENTEDGE	;
	call	CreateWindowEx		;
	mov	ebx, eax		; save window handle    

	push	-1			; Set font
	push	hFont			;
	push	WM_SETFONT		;
	push	eax			;
	call	SendMessage		;
	
	push	0			;
	push	hInstance		;
	push	0			;
	push	hWnd			;
	push	0			; Height
	push	0			; Width
	push	0			; Top
	push	0			; Left
	push	WS_CHILD\		;
		or WS_VISIBLE\
		or UDS_ALIGNRIGHT\
		or UDS_SETBUDDYINT 
	push	0			; 
	push	offset WndClsUpDown	;
	push	0			;
	call	CreateWindowEx		;
	push	eax			; save updown handle
	
	push	0			; set text box as buddy for updown
	push	ebx			;
	push	UDM_SETBUDDY		;
	push	eax			;
	call	SendMessage		;
	pop	eax			; restore updown handle=
	
	push	5000			; set updown range 5000 = upper
	push	1			; 1= lower
	push	UDM_SETRANGE32		;
	push	eax			;
	call	SendMessage		;

					; #####################################   
					; time type Combobox  control
	push    0			;
	push    hInstance		;
	push    0			;
	push    hWnd			;
	push    110			; Height
	push    100			; Width
	push    45			; Top
	push    150			; Left
	push    WS_CHILD\		;
		or WS_VISIBLE\		;
		or CBS_DROPDOWNLIST\	;
		or CBS_SORT		;
	push    0			; 
	push    offset WndClsCombo	;
	push    0			;
	call    CreateWindowEx		;
	mov	ebx, eax
	
	push    -1			; Set font
	push    hFont			;
	push    WM_SETFONT		;
	push    eax			;
	call    SendMessage		;	
	
	push	offset szMillis		; add our combo box strings
	push	0			;
	push	CB_ADDSTRING		;
	push	ebx			;
	call	SendMessage		;
					;
	push	offset szSecs		;
	push	0			;
	push	CB_ADDSTRING		;
	push	ebx			;
	call	SendMessage		;
					;
	push	offset szMins		;
	push	0			;
	push	CB_ADDSTRING		;
	push	ebx			;
	call	SendMessage		;
					;
	push	offset szHours		;
	push	0			;
	push	CB_ADDSTRING		;
	push	ebx			;
	call	SendMessage		;
					;
	push	offset szDays		;
	push	0			;
	push	CB_ADDSTRING		;
	push	ebx			;
	call	SendMessage		;
					;
	push	offset szWeeks		;
	push	0			;
	push	CB_ADDSTRING		;
	push	ebx			;
	call	SendMessage		;
					;
	push	offset szYears		;
	push	0			;
	push	CB_ADDSTRING		;
	push	ebx			;
	call	SendMessage		;
					
					; #####################################   
					; crash after button control
	push	0			;
	push	hInstance		;
	push	0			;
	push	hWnd			;
	push	20			;
	push	80			;
	push	70			;
	push	10			;
	push	WS_CHILD\		;
		or WS_VISIBLE\		;
		or BS_AUTOCHECKBOX 	;
	push	offset Text4		; 
	push	offset WndClsButton	;
	push	0			;
	call	CreateWindowEx		;
	
	push	-1			;
	push	hFont			;
	push	WM_SETFONT		;
	push	eax			;
	call	SendMessage		;

	push	0			;        
	push	hInstance		;
	push	0			;
	push	hWnd			;
	push	20			; Height
	push	50			; Width
	push	70			; Top
	push	90			; Left
	push	WS_CHILD\		;
		or WS_VISIBLE\		;
		or ES_NUMBER
	push	0			; 
	push	offset WndClsEdit	;
	push	WS_EX_CLIENTEDGE	;
	call	CreateWindowEx		;
	mov	ebx, eax
	push	-1			; Set font
	push	hFont			;
	push	WM_SETFONT		;
	push	eax			;
	call	SendMessage		;
	
	push	0
	push	6
	push	EM_SETLIMITTEXT
	push	ebx
	call	SendMessage

	push	0			;        
	push	hInstance		;
	push	0			;
	push	hWnd			;
	push	20			; Height
	push	150			; Width
	push	75			; Top
	push	145			; Left
	push	WS_CHILD\		;
		or WS_VISIBLE
	push	offset Text5			; 
	push	offset WndClsStatic	;
	push	0			;
	call	CreateWindowEx		;
	mov	ebx, eax
	push	-1			; Set font
	push	hFont			;
	push	WM_SETFONT		;
	push	eax			;
	call	SendMessage		;

					; #####################################
					; Save options static control                  
	push	0 			;    
	push	hInstance		;
	push	0			;
	push	hWnd			;
	push	20			; Height
	push	70			; Width
	push	100			; Top
	push	5			; Left
	push	WS_CHILD\		;
		or WS_VISIBLE		;
	push	offset Text6		;
	push	offset WndClsStatic	;
	push	0			;
	call	CreateWindowEx		;
	
	push	-1			; Set font
	push	hFont			;
	push	WM_SETFONT		;
	push	eax			;
	call	SendMessage		;

    					; #####################################
					; Create large files button control
	push	0			;
	push	hInstance		;
	push	0			;
	push	hWnd			;
	push	20			; Height
	push	200			; Width
	push	120			; Top
	push	10			; Left
	push	WS_CHILD\		;
		or WS_VISIBLE\		;
		or BS_AUTOCHECKBOX 	;
	push	offset Text7		; 
	push	offset WndClsButton	;
	push	0			;
	call	CreateWindowEx		;

	push	-1			; Set font
	push	hFont			;
	push	WM_SETFONT		;
	push	eax			;
	call	SendMessage		;

					
					; #####################################   
					; AS carry on button control
	push	0			;
	push	hInstance		;
	push	0			;
	push	hWnd			;
	push	20			;
	push	310			;
	push	140			;
	push	10			;
	push	WS_CHILD\		;
		or WS_VISIBLE\		;
		or BS_AUTOCHECKBOX 	;
	push	offset Text8		; 
	push	offset WndClsButton	;
	push	0			;
	call	CreateWindowEx		;
	
	push	-1			;
	push	hFont			;
	push	WM_SETFONT		;
	push	eax			;
	call	SendMessage		;

					; #####################################
					; AR takes static control                  
	push	0 			;    
	push	hInstance		;
	push	0			;
	push	hWnd			;
	push	20			; Height
	push	150			; Width
	push	165			; Top
	push	10			; Left
	push	WS_CHILD\		;
		or WS_VISIBLE		;
	push	offset Text9		;
	push	offset WndClsStatic	;
	push	0			;
	call	CreateWindowEx		;
	
	push	-1			; Set font
	push	hFont			;
	push	WM_SETFONT		;
	push	eax			;
	call	SendMessage		;

					; #####################################   
					; AR takes Combobox  control
	push    0			;
	push    hInstance		;
	push    0			;
	push    hWnd			;
	push    110			; Height
	push    130			; Width
	push    165			; Top
	push    150			; Left
	push    WS_CHILD\		;
		or WS_VISIBLE\		;
		or CBS_DROPDOWNLIST\	;
		or CBS_SORT		;
	push    0			; 
	push    offset WndClsCombo	;
	push    0			;
	call    CreateWindowEx		;
	mov	ebx, eax
	
	push    -1			; Set font
	push    hFont			;
	push    WM_SETFONT		;
	push    eax			;
	call    SendMessage		;	
	
	push	offset sz1		; add our combo box strings
	push	0			;
	push	CB_ADDSTRING		;
	push	ebx			;
	call	SendMessage		;
					;
	push	offset sz2		;
	push	0			;
	push	CB_ADDSTRING		;
	push	ebx			;
	call	SendMessage		;
					;
	push	offset sz3		;
	push	0			;
	push	CB_ADDSTRING		;
	push	ebx			;
	call	SendMessage		;
					;
	push	offset sz4		;
	push	0			;
	push	CB_ADDSTRING		;
	push	ebx			;
	call	SendMessage		;

					; #####################################
					; Other options static control                  
	push	0 			;    
	push	hInstance		;
	push	0			;
	push	hWnd			;
	push	20			; Height
	push	70			; Width
	push	195			; Top
	push	5			; Left
	push	WS_CHILD\		;
		or WS_VISIBLE		;
	push	offset Text10		;
	push	offset WndClsStatic	;
	push	0			;
	call	CreateWindowEx		;
	
	push	-1			; Set font
	push	hFont			;
	push	WM_SETFONT		;
	push	eax			;
	call	SendMessage		;
	
    					; #####################################
					; Piss me off button control
	push	0			;
	push	hInstance		;
	push	0			;
	push	hWnd			;
	push	30			; Height
	push	300			; Width
	push	210			; Top
	push	10			; Left
	push	WS_CHILD\		;
		or WS_VISIBLE\		;
		or BS_AUTOCHECKBOX\	;
		or BS_MULTILINE
	push	offset Text11		; 
	push	offset WndClsButton	;
	push	0			;
	call	CreateWindowEx		;

	push	-1			; Set font
	push	hFont			;
	push	WM_SETFONT		;
	push	eax			;
	call	SendMessage		;

					; #####################################
					; Annoy me static control                  
	push	0 			;    
	push	hInstance		;
	push	0			;
	push	hWnd			;
	push	20			; Height
	push	200			; Width
	push	245			; Top
	push	10			; Left
	push	WS_CHILD\		;
		or WS_VISIBLE		;
	push	offset Text12		;
	push	offset WndClsStatic	;
	push	0			;
	call	CreateWindowEx		;
	
	push	-1			; Set font
	push	hFont			;
	push	WM_SETFONT		;
	push	eax			;
	call	SendMessage		;
		
    					; #####################################
					; Constantly button control
	push	0			;
	push	hInstance		;
	push	0			;
	push	hWnd			;
	push	20			; Height
	push	300			; Width
	push	265			; Top
	push	20			; Left
	push	WS_CHILD\		;
		or WS_VISIBLE\		;
		or BS_AUTORADIOBUTTON 	;
	push	offset Text13		; 
	push	offset WndClsButton	;
	push	0			;
	call	CreateWindowEx		;

	push	-1			; Set font
	push	hFont			;
	push	WM_SETFONT		;
	push	eax			;
	call	SendMessage		;
	
    					; #####################################
					; Least expect it button control
	push	0			;
	push	hInstance		;
	push	0			;
	push	hWnd			;
	push	20			; Height
	push	300			; Width
	push	285			; Top
	push	20			; Left
	push	WS_CHILD\		;
		or WS_VISIBLE\		;
		or BS_AUTORADIOBUTTON 	;	
	push	offset Text14		; 
	push	offset WndClsButton	;
	push	0			;
	call	CreateWindowEx		;

	push	-1			; Set font
	push	hFont			;
	push	WM_SETFONT		;
	push	eax			;
	call	SendMessage		;
	
    					; #####################################
					; Never button control
	push	0			;
	push	hInstance		;
	push	0			;
	push	hWnd			;
	push	30			; Height
	push	270			; Width
	push	305			; Top
	push	20			; Left
	push	WS_CHILD\		;
		or WS_VISIBLE\		;
		or BS_AUTORADIOBUTTON\	;
		or BS_MULTILINE		;
	push	offset Text15		; 
	push	offset WndClsButton	;
	push	0			;
	call	CreateWindowEx		;

	push	-1			; Set font
	push	hFont			;
	push	WM_SETFONT		;
	push	eax			;
	call	SendMessage		;
;***************************************************
    					; #####################################
					; Ok button control
	push	0			;
	push	hInstance		;
	push	1			;
	push	hWnd			;
	push	20			; Height
	push	60			; Width
	push	340			; Top
	push	130			; Left
	push	WS_CHILD\		;
		or WS_VISIBLE\		;
		or BS_PUSHBUTTON
	push	offset szOk		; 
	push	offset WndClsButton	;
	push	0			;
	call	CreateWindowEx		;

	push	-1			; Set font
	push	hFont			;
	push	WM_SETFONT		;
	push	eax			;
	call	SendMessage		;
	
	    					; #####################################
					; Cancel button control
	push	0			;
	push	hInstance		;
	push	2			;
	push	hWnd			;
	push	20			; Height
	push	60			; Width
	push	340			; Top
	push	200			; Left
	push	WS_CHILD\		;
		or WS_VISIBLE\		;
		or BS_PUSHBUTTON
	push	offset szCancel		; 
	push	offset WndClsButton	;
	push	0			;
	call	CreateWindowEx		;

	push	-1			; Set font
	push	hFont			;
	push	WM_SETFONT		;
	push	eax			;
	call	SendMessage		;
	
	    					; #####################################
					; Reset button control
	push	0			;
	push	hInstance		;
	push	3			;
	push	hWnd			;
	push	20			; Height
	push	60			; Width
	push	340			; Top
	push	270			; Left
	push	WS_CHILD\		;
		or WS_VISIBLE\		;
		or BS_PUSHBUTTON
	push	offset szReset		; 
	push	offset WndClsButton	;
	push	0			;
	call	CreateWindowEx		;

	push	-1			; Set font
	push	hFont			;
	push	WM_SETFONT		;
	push	eax			;
	call	SendMessage		;
	mov	eax, 0
	ret
	
.elseif uMsg == WM_DESTROY

    push    hFont                    ; Destroy normal font
    call    DeleteObject                ;
    
    push    0                           ; we are done, inform OS
    call    PostQuitMessage    
	mov	eax, 0
	ret
.endif
    push    lParam                      ; pass on all other messages
    push    wParam                      ;
    push    uMsg                        ;
    push    hWnd                        ;
    call    DefWindowProc               ;
    ret
ProcMain endp

Paint_Proc proc uses ebx edi esi hWin:DWORD, hDC:DWORD

	push	COLOR_3DSHADOW
	call	GetSysColor
	mov	esi, eax

	push	esi
	push	1
	push	0
	call	CreatePen
	mov	ebx, eax
	
	push	eax
	push	hDC
	call	SelectObject
	mov	edi, eax

	push	0
	push	33
	push	5
	push	hDC
	call	MoveToEx
	
	push	33
	push	330
	push	hDC
	call	LineTo
	
	push	edi
	push	hDC
	call	SelectObject
	
	push	ebx
	call	DeleteObject

	push	 COLOR_3DHIGHLIGHT
	call	GetSysColor
    push    eax
    push    1
    push    0
    call    CreatePen
    mov     ebx, eax

    push    eax
    push    hDC
    call    SelectObject
    mov     edi, eax

    push    0
    push    34
    push    5
    push    hDC
    call    MoveToEx

    push    34
    push    330
    push    hDC
    call    LineTo

    push    edi
    push    hDC
    call    SelectObject

    push    ebx
    call    DeleteObject    

;*********************************************************************
	push	esi
	push	1
	push	0
	call	CreatePen
	mov	ebx, eax
	
	push	eax
	push	hDC
	call	SelectObject
	mov	edi, eax

	push	0
	push	105
	push	5
	push	hDC
	call	MoveToEx
	
	push	105
	push	330
	push	hDC
	call	LineTo
	
	push	edi
	push	hDC
	call	SelectObject
	
	push	ebx
	call	DeleteObject

	push	 COLOR_3DHIGHLIGHT
	call	GetSysColor
    push    eax
    push    1
    push    0
    call    CreatePen
    mov     ebx, eax

    push    eax
    push    hDC
    call    SelectObject
    mov     edi, eax

    push    0
    push    106
    push    5
    push    hDC
    call    MoveToEx

    push    106
    push    330
    push    hDC
    call    LineTo

    push    edi
    push    hDC
    call    SelectObject

    push    ebx
    call    DeleteObject    
;***********************************************************************************
	push	esi
	push	1
	push	0
	call	CreatePen
	mov	ebx, eax
	
	push	eax
	push	hDC
	call	SelectObject
	mov	edi, eax

	push	0
	push	200
	push	5
	push	hDC
	call	MoveToEx
	
	push	200
	push	330
	push	hDC
	call	LineTo
	
	push	edi
	push	hDC
	call	SelectObject
	
	push	ebx
	call	DeleteObject

	push	 COLOR_3DHIGHLIGHT
	call	GetSysColor
    push    eax
    push    1
    push    0
    call    CreatePen
    mov     ebx, eax

    push    eax
    push    hDC
    call    SelectObject
    mov     edi, eax

    push    0
    push    201
    push    5
    push    hDC
    call    MoveToEx

    push    201
    push    330
    push    hDC
    call    LineTo

    push    edi
    push    hDC
    call    SelectObject

    push    ebx
    call    DeleteObject    

    ret

Paint_Proc endp

end Start